// Copyright 2013, University of Freiburg,
// Image Analysis Lab
// Author: Olaf Ronneberger <ronneber>

#include <gtest/gtest.h>
#include <sstream>
#include <string>
#include <vector>
#include "./Sorter.h"

template< typename T>
std::string myVectorToString(std::vector<T> v) {
  std::ostringstream oss;
  oss << "[";
  for (size_t i = 0; i < v.size(); ++i) {
    if (i > 0) oss << ", ";
    oss << v[i];
  }
  oss << "]";
  return oss.str();
}



// _____________________________________________________________________________
TEST(Sorter, minSort) {
  int data[] = { 17, 4, 32, 19, 8, 44, 1 };
  std::vector<int> array1(data, data+7);

  Sorter::minSort(&array1);
  ASSERT_EQ("[1, 4, 8, 17, 19, 32, 44]", myVectorToString(array1));

  std::vector<int> array2;  // empty array
  Sorter::minSort(&array2);
  ASSERT_EQ("[]", myVectorToString(array2));
}
